<?php
   
   /*
      Copyright 2019 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Data: 14/09/2019
	  Autor: Alexandre P. Trindade
	  Versão 2.0

      Script para publicação de IP do sistem 100ip.com.br
	  Executa o post das alterações de IPs nos registros das Zonas de DNS
	  
	  A Versão 2.0 não utiliza a API do CPanel
   */

   // Define o path da biblioteca
   $root     = $_SERVER["DOCUMENT_ROOT"];
   $lib_path = $root."/_ulibb_";

   $LAST_ERROR = "";

   require_once($lib_path."/ulib.php");
   // "lib_get",
   uses("lib_misc","jc_padrao","jc_mysql","o_mysqlquery");

   require_once("$root/connections/conn.php");
   require_once("publica-ip_funcoes.php");

   $body=file_get_contents("php://input");
   $sid='';
   
   if (isset($_GET) && isset($_GET['sid'])){ 
      $sid = $_GET['sid']; 
   }else{
      die("Chamada de função inválida !"); 
   }
   
   // Altentica a chamada
   $key_a=explode(",", $sid);
   $key="100ip.com.br" . $key_a[1];
   $key = strtolower( md5( $key ) );

   if ($key !== $key_a[0]){
      die("Erro de autenticação de procedencia !");
   }
   
   $linhas=explode( "\n", $body);

   foreach($linhas as $linha){
	  if (!empty($linha)){
	     $reg=explode(":", $linha);
		 updateDB( $reg[0].".100ip.com.br", $reg[4]);
	  }
   }
   
   if (empty($LAST_ERROR)){
	   echo "Ok";
   }else{
	   echo "Erro: $LAST_ERROR";
   }