<?php
   /*
      Copyright 2013 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Data: 07/08/2013
	  Atualizado em: 14/09/2019
	  Autor: Alexandre P. Trindade
	  Versão 2.0

      Script para publicação de IP do sistem 100ip.com.br
      API do Client:
             - Verifica se o ip do client mudou
			 - Posta o update do Ip para o servidor do serviço em newton.unsvr.com
			 
	  A Versão 2.0 não utiliza a API do CPanel
			 
   */

   // Define o path da biblioteca
   $root     = $_SERVER["DOCUMENT_ROOT"];
   $lib_path = $root."/_ulibb_";

   require_once($lib_path."/ulib.php");
   uses("lib_get","lib_misc","jc_padrao","jc_mysql","o_mysqlquery");

   require_once("$root/connections/conn.php");
   require_once("publica-ip_funcoes.php");


   $chave = hex_decode( getParam_s("chave","","post","t-s-") );
   $name  = hex_decode( getParam_s("dominio","","post","t-l-s-") );
   $IP_CALLER = $_SERVER["REMOTE_ADDR"];
   $LAST_ERROR = "";

   if (needUpdate($name,$chave)){
      if (atualizaZonaDNS($name, $IP_CALLER)){
         echo "OK|$IP_CALLER|Ip atualizado no registro de DNS";
      }else{
         echo "Erro|$LAST_ERROR"; 
      }
   }else{
      if (!empty($LAST_ERROR)){
         echo "Erro (db)|$LAST_ERROR";
      }else{
         echo "OK|$IP_CALLER|IP já publicado.";
      }
   }


