<?php
   /*
      Funes para tratamento de e-mail
      Autor.: Alexandre P. Trindade
      Inicio: 15/09/2004 
      Copyright Uniware Informtica
   */

    if (!isset($lib_path)) {$lib_path = ".";}
	/*{$NC+}*/
	require_once($lib_path."/lib_io.php");
    /*{$NC-}*/
    /*{$CB+}
    uses("lib_io");
    {$CB-}*/

   /** Obsoleto **/
   function ValidEMail($email = ""){
      if (!empty($email)){
	     $result = (!(strpos($email,"@") === false) && !(strpos($email,".") === false) && !empty($email) && strlen($email) > 6);
		 return $result;
	  }else{
	     return false; 
	  }
   }
   /*
      Send_Mail - Enivia e-mail genrico 
	  Parmetros:
        $mail_to         - e-mail do destinatrio da mensagem
        $nome_to         - Nome do destinatrio
	    $mail_from       - e-mail de origem
	    $nome_from       - nome da origem
	    $mail_rep        - e-mail para replay
	    $nome_rep        - nome do destinatrio do replay
	    $assunto         - assunto da mensagem
	    $mensagem        - mensagem
	    $tipo            - [opcional] tipo da mensagem: 0 = texto (default) 1 = Html
   */
   
   function MailHeader($mail_to,$nome_to,$mail_from,$nome_from,$mail_rep,$nome_rep){
	  $result  = "MIME-Version: 1.0\r\n";
	  $result .= "Content-type: text/html; charset=iso-8859-1\r\n";
	  $result .= "To: $nome_to <$mail_to>\r\n";
	  $result .= "From: $nome_from <$mail_from>\r\n";
      $result .= "Reply-To: $nome_rep <$mail_rep>\r\n";
      return  $result;  
   }

   function Send_Mail($mail_to,$nome_to,$mail_from,$nome_from,$mail_rep,$nome_rep,$assunto,$mensagem,$tipo = 0) {

     if (empty($nome_rep)){ $nome_rep = $nome_from; }
	 if (empty($mail_rep)){ $mail_rep = $mail_from; }
	 
	 $headers  = MailHeader($mail_to,$nome_to,$mail_from,$nome_from,$mail_rep,$nome_rep);

     if ($tipo == 0) {
        $mensagem     =  "<HTML><HEAD></HEAD><BODY>\r\n" . nl2br($mensagem) . "\r\n</BODY></HTML>\r\n";
	 }
	 //r: Nota: Para servidores Windows, ativar o 5 parmetro (,"-f$mail_from")
	 return @mail($mail_to,$assunto,$mensagem,$headers); //r: ,"-f$mail_from"
   }

   /* envia e-mail com layout definido por template
      Parmetros:
	     $a_header   - Informaes obrigatrias do header
		               ndices:
		                         mail_to    : Destinatrio do email.
								 nome_to    : Nome do destinatrio.
								 mail_from  : E-mail do remetente
								 nome_from  : Nome do Remetente
								 mail_rep   : Endereo para Resposta
								 nome_rep   : Nome do destinatrio da resposata
								 subject    : Assunto da mensagem
								 mensagem   : Mensagem alternativa (caso o arquivo template nao seja encontrado)

		$a_mail    - Arrai contendo os dados do e-mail, cada indice do array corresponde a uma varivel no template

		$template_file_name  - Nome do arquivo de template correspondnte
   */
   function SendMailFmt($a_header,$a_mail,$template_file_name){
	   $template = file_exists($template_file_name);
       if ($template !== false && !empty($template)){
 	      $headers  = MailHeader($a_header["mail_to"],$a_header["nome_to"],
			                     $a_header["mail_from"],$a_header["nome_from"],
			                     $a_header["mail_rep"],$a_header["nome_rep"]);

          $template = GetDocFromTemplate($a_mail["MAIL_DATA"],$a_mail["VAR_DELIM"],$template_file_name);
          return @mail($a_header["mail_to"],$a_header["subject"],$template,$headers);
	   }else{
	      return Send_Mail($a_header["mail_to"],$a_header["nome_to"],
			               $a_header["mail_from"],$a_header["nome_from"],
			               $a_header["mail_rep"],$a_header["nome_rep"],
			               $a_header["subject"],$a_header["mensagem"]);
	   }
   }
?>
