<?php
  /*
   *  Acesso ao banco de dados via cgi "cgi-mysql".
   *  Autor.: Alexandre P. Trindade
   *  Data..: 14/06/2010
   *
  */

  define("CGI_START_BLOCK","CGI-MYSQL-RESULTSET-U201006");
  define("CGI_START_BLOCK_SIZE",strlen(CGI_START_BLOCK)+2);
  define("CGI_END_BLOCK","::CGI-MYSQL-END>>");
  define("CGI_END_BLOCK_SIZE",strlen(CGI_END_BLOCK));

  class uHttpCgiDb{
     var $url;
     var $form;
     var $lastError;
     var $paginado;
     var $limit;
     var $currentPage;
     var $allRecord;
     var $fPageCount;
     var $fRecIni;
     var $fRecordCount;
     var $ioResult;
     var $trimData;
     var $OnLoadRec;
     var $porta;
     var $textHtml;
     var $blobText;

     function uHttpCgiDb(){
        $this->url = "";
        $this->form = array();
        $this->form["UHTTPFILEDCTRL"] = "CZ1";
        $this->form["COMANDO"]  = "OPEN";
        $this->form["LIMIT"]    = "NOLIMIT";
        $this->form["TRIM"]     = "FALSE";
        $this->form["RSQL"]     = "";
        
        $this->lastError = "";
        $this->paginado  = false;
        $this->limit     = false;
        $this->currentPage    = 1;
        $this->allRecord = 0;
        $this->fPageCount = 0;
        $this->fRecIni    = 0;
        $this->fRecordCount = 0;
        $this->ioResult = 0;
        $this->trimData = "FALSE";
        $this->OnLoadRec = "";
        $this->porta = 80;
        $this->multSQL = false;
        $this->textHtml      = false;
        $this->blobText      = false;
     }

     function SetSQL($psql){
        $this->form["RSQL"] = $psql;
     }
     
     function Open(){
        $this->form["COMANDO"] = "OPEN";
        if ($this->paginado){
           if ($this->currentPage < 1){ $this->currentPage = 1; }
           $this->calcRecIni();
           $ri = $this->fRecIni; $lmt = $this->limit;
           $this->form["LIMIT"] = "$ri, $lmt";
        }
        return $this->query();
     }
  
     function ExecSQL(){
        $this->form["COMANDO"] = "EXEC";
        return $this->query();
     }

     function processResult(&$a_result){
        $this->fRecordCount = count($a_result);
        if ($this->fRecordCount == 1){
           $a = $a_result[0];

           if ($a["result"] == "1"){
              $this->ioResult = 1;
              $this->lastError = $a["erro"];
           }else{
              $this->ioResult = 0;
           }
        }
        if ($this->allRecord > 0){
           $this->fPageCount  = (int) ($this->allRecord / $this->limit);
           
		   if (($this->allRecord % $this->limit) > 0) {
				   $this->fPageCount += 1;
		   }if ($this->allRecord > 0 & $this->fPageCount == 0){
                $this->fPageCount += 1;
           }

	       if ($this->currentPage > $this->fPageCount){
              $this->currentPage = $this->fPageCount;
		   }
		   if ($this->currentPage < 1) {
			   $this->currentPage = 1;
		   }
           //r: Registro inicial
           $this->fRecIni  = $this->limit * ($this->currentPage -1);
        }else{
           $this->currentPage  = 1;
           $this->fPageCount   = 0;
           $this->fRecIni      = 0;
        }
     }
     
     function RecordCount(){
        return $this->fRecordCount;
     }
     
     function PageCount(){
       return $this->fPageCount;
     }
     
     function PgRecordCount(){
       return $this->allRecord;
     }
     
     function PgStartRecord(){
       return $this->fRecIni;
     }
     
     function calcRecIni(){
        $this->fRecIni  = $this->limit * ($this->currentPage -1);
     }
     
     function postData($query,$others=''){
       $host = $this->url;
       $path =explode('/',$host);
       $host =$path[0];
       unset($path[0]);
       $path='/'.(implode('/',$path));
       $post="POST $path HTTP/1.1\r\nHost: $host\r\nContent-type: application/x-www-form-urlencoded\r\n${others}User-Agent: Mozilla 4.0\r\nContent-length: ".strlen($query)."\r\nConnection: close\r\n\r\n$query";

       $h = fsockopen($host,$this->porta,$iErr,$erMsg,5);
       if ($h !== false){
           fwrite($h,$post);

           $r = "";
           while (!feof($h)) {
             $r .= fgets($h, 128);
           }
           fclose($h);
           $i = strpos($r,CGI_START_BLOCK);
           if ($i !== false){
              $r = substr($r,$i+CGI_START_BLOCK_SIZE);
           }

           $i = strpos($r,CGI_END_BLOCK);
           if ($i !== false){
              $r = substr($r,0,$i-2);
           }
      }else{
         $this->ioResult  = $iErr;
         $this->lastError = $erMsg;
      }
       return $r;
     }
     
     function postForm(){
       $qry = "";
       if (is_array($this->form)){
          foreach($this->form as $k => $v){
            $qry .= $this->iif(empty($qry),"?$k=","&$k=");
            $qry .= urlencode($v);
          }
          return $this->postData($qry);
       }else{
         $this->ioResult = 1;
         $this->lastError = "uCgiDbQuery.postForm() erro: Formulario no definido.";
         return false;
       }
     }

     function query(){
        $ds = $this->postForm();
        if ($ds !== false){
            $alinhas = explode("\r\n",$ds);

            $a_result = array();
            if ( count($alinhas) > 1 ){
               $arc = explode("=",$alinhas[0]);
               $this->allRecord = $arc[1];
               $a_result = array();
               $aFields = explode(chr(3),$alinhas[1]); $alinhas[1] = "";
               $i = 2;
               while ($i<count($alinhas)){
                  $l = explode(chr(3),$alinhas[$i]); $alinhas[$i] = ""; $rec = array();
                  $j = 0;
                  while ($j < count($l)){
                     if ($this->blobText){
                        $rec[$aFields[$j]] = str_replace(chr(2),$CrLf, $l[$j]);
                     }else{
                        $rec[$aFields[$j]] = $l[$j];
                     }
                     $j += 1;
                  }
                  if (!empty($this->OnLoadRec)){
		             $cmd = $this->OnLoadRec . '($this,$rec);';
		             eval($cmd);
                  }
                  array_push($a_result,$rec);
                  $i += 1;
               }
            }
            $this->processResult($a_result);
            return $a_result;
        }else{
           return false;
        }
    }
         
    function iif($e,$p1,$p2){
       if ($e){
          return $p1;
       }else{
          return $p2;
       }
    }

  }
?>
