<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004

	  Classe para gerao de arquivos de log
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/objects.php");
  /*{$NC-}*/
  /*{$CB+}
  uses("objects");
  {$CB-}*/

  class uLogCtrl extends uObject {
	  //r: Propriedades
	  var $logName;
	  var $path;
	  var $maxLogFileSize;
	  var $saveTime;

	  function uLogCtrl(){
	      $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uLogCtrl";
	      $classPath = (func_num_args() > 1)?  "uLogCtrl.".func_get_arg(1):"uLogCtrl";

		  $this->uObject($name,$classPath); //r: inherited

        $this->logName        = "log_default";
	     $this->path           = $_SERVER["DOCUMENT_ROOT"]."/_logs";
	     $this->maxLogFileSize = 3 * (1024 * 1024);    //r:Tamanho mximo para o arquivo de log (default 3Mb)
        $this->saveTime       = false;

	  }

	  //r: Retorna um nome para arquivo de log
	  function pv_getFileName() {
		 $path    = $this->path;
		 $maxsize = $this->maxLogFileSize;
		 $fname   = $path."/".$this->logName."_".str_pad("1",10,"0",STR_PAD_LEFT).".log";
		 $fcount  = 1;
		 $inifile = $path."/".$this->logName."_sys.cfg";

		 if (!file_exists($inifile)) {
			$inihand = fopen($inifile,"wb");
			if ($inihand) {
			   fwrite($inihand, str_pad("1",10,"0",STR_PAD_LEFT));
			   fwrite($inihand, str_pad($fname,150));
			   fclose($inihand);
			   return $fname;
			} }
		 else {
		   $inihand = fopen($inifile,"r+b");
		   if ($inihand) {
			  $fcount = fread($inihand,10);
			  $fname  = trim(fread($inihand,150));
			  If (file_exists($fname)) {
				 If (filesize($fname) >= $this->maxLogFileSize) {
					$fcount = $fcount + 1;
					$fname  = $path."/".$this->logName."_" . str_pad($fcount,10,"0",STR_PAD_LEFT) . ".log";
					rewind($inihand);
					fwrite($inihand, str_pad($fcount,10,"0",STR_PAD_LEFT));
					fwrite($inihand, str_pad($fname,150));
				 }
			  }
			 fclose($inihand);
		   }
		 }
		 return $fname;
	  }


	  function AddLog($msg) {
		$filename = $this->pv_getFileName();
		$fhandle  = fopen($filename,"ab");

        if ($this->saveTime){
		    $msg = date("d\/m\/Y H:i:s") . "\r\n" . $msg;
		}

		If ($fhandle) {
		   fwrite($fhandle, $msg . "\r\n");
		   fclose($fhandle);
		}
	  }

  }
?>
