<?php
  /* ---------------------------------------------------------------------------
     uLib Versao 3.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
     Inicio: 15/09/2004
	 ---------------------------------------------------------------------------
  */
  /*{$NC+}   nao compilar este bloco */
  // require_once($lib_path."/objects.php");
  // require_once($lib_path."/lib_misc.php");
  uses("objects","lib_misc");
  /*{$NC-}*/
  /*{$CB+}  Compilar este bloco
  uses("objects","lib_misc");
  {$CB-}*/

  function getDeltaErro($rowsAffec,$errNum,$errStr,$encriptMode){
       $linha_zero = "strCount=1|rowsaffect=$rowsAffec|errNum=$errNum|errStr=$errStr";
       //r: codifica a linha do header
       $linha_zero = ($encriptMode == 1)? SoftEncode($linha_zero):$linha_zero;
       $linha_zero = ($encriptMode == 2)? hex_encode($linha_zero):$linha_zero;
       $linha_zero = ($encriptMode == 3)? str_to_hex($linha_zero):$linha_zero;
       return "\r\n<!--\r\n".$linha_zero."\r\n-->\r\n";
  }

  function encodeString($str,$encriptMode){
     if ($encriptMode == 1){
        return SoftEncode($str);
     }else if ($encriptMode == 2){
        return hex_encode($str);
     }else if ($encriptMode == 3){
        return str_to_hex($str);
     }else{
       return SoftEncode($str);
     }
  }
  
   function decodeString($str, $encriptMode){
      if ($encriptMode == 1){
         return  SoftEncode( $str, true );
      }else if ($encriptMode == 2){
         return hex_decode( $str );
      }else if ($encriptMode == 3){
         return  hex_to_str( $str );
      }else{
         return false;
      }
   }

   /* Prepara a SQL para execuo (substitui parmetros por valores)
      Nota o nome do paramepro na lista  composto de:
           tipo+nomeParam ou seja TNNNNNNN...
       onde T  o caracter de formato (N = Numrico e S = String) que define de
       o valor deve ou no estar entra aspas na SQL
       
       Formato do array $Params:
          $Params["nomeParametroIncluindoOTipo"] = ParamValor
   */
   function PrepareSQL($sql,$Params){
      foreach($Params as $k => $value){
         $type = substr($k,0,1);
         $name = ":" . substr($k,1);
         $valor = ($tipo=="N")?  $value:"'$value'";
         $sql = str_replace($name,$valor,$sql);
      }
      return $sql;
   }

  class uPostgreSQLQuery extends uObject {
	 var $conexao;              //r: identificador de conexo
     var $db_fieldDef;          //r: Definicoes dos campos no banco de dados
	 var $lastError;            //r: Descrio do ultimo erro ocorrido
     var $date_br;              //r: Se true as datas sero retornadas no formato dd/mm/aaaa

	 var $paginado;             //r: Apresentar resultado em paginas
	 var $currentPage;          //r: Nmero da pgina que dever ser exibida
	 var $limit;                //r: Registros por pgina
     var $CountSQL;             //r: SQL alternativa para avaliao de registros afetados/encontrados

	 var $OnLoadRec;            //r: Evento OnLoadRec(&$sender)

    //r: Privados
	 var $SQL;                  //r: Privado - Instruo SQL
	 var $fSQLo;                //r: Privado - uso interno
	 var $fRrecIni;             //r: Privado - Registro Inicial;
	 var $fPageCount;           //r: Privado - Total de pginas (modo paginado)
	 var $fAllRecCount;         //r: Privado - Total geral de registro (modo paginado)

     var $fActive;              //r: Privado - indica se uma consulta (select) esta aberta
	 var $fRS;                  //r: Privado - Result set.
	 var $fRecCount;            //r: Privado - Nmero de registros retornados
	 var $fRecno;               //r: Privado - Nmero do registro corrente
	 var $fBuffer;              //r: Privado - Buffer para registro lido
     var $fSide;                //r: Privado - Flag indicador de inicio e fim de arquivo (0 = bof, 2 = eof)
    function uPostgreSQLQuery() {
	     $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uPostgreSQLQuery";
	     $classPath = (func_num_args() > 1)?  "uMySQLQuery.".func_get_arg(1):"uPostgreSQLQuery";

		  $this->uObject($name,$classPath); //r: inherited

		  if ($this->onFree != "") {
		     $this->onFree     .= '($this);$this->uPostgreSQLQueryDestroy';
		  }else{
	          $this->onFree     = '$this->uPostgreSQLQueryDestroy';
		  }

		  $this->db_fieldDef     = array();
		  $this->cahe_fieldDef   = array();
		  $this->conexao         = -1;
		  $this->SQL             = "";
		  $this->lastError       = "";
		  $this->date_br         = false;
		  $this->fActive         = false;
		  $this->fRS             = false;
		  $this->fRecCount       = 0;
		  $this->fRecno          = 0;
		  $this->OnLoadRec       = "";

		  $this->fSQLo           = "";
		  $this->currentPage     = 0;
		  $this->paginado        = false;
		  $this->limit           = 0;
		  $this->fPageCount      = 0;
		  $this->fRecIni         = 0;
		  $this->fAllRecCount    = 0;
	}
   
    function _HaveData(){
	  return ($this->fActive === true && $this->RecordCount() > 0);
	}
    
    function SQL(){
	   return $this->SQL;
	}

    function SQLClear(){
	   $this->SQL = "";
	   $this->fSQLo = "";
	}

    Function SQLAdd($text){
	   if (empty($this->SQL)) {
	      $this->SQL = $text;
	   }else{
	      $this->SQL .= " $text";
	   }
	}

    function GetCommand(){
	   return $this->fSQLo;
	}

    function Active(){
	  return $this->fActive;
	}
    function Bof(){
	   return $this->fSide == 0;
	}

    function Eof(){
	   return $this->fSide == 2;
	}

    function uPostgreSQLQueryDestroy(){
       $this->Close();
	}
  
    function _PostgreErr($err){
	    $this->lastError = $err;
	}

    function GetBuffer(){
	   return $this->GetARecord();
	}

    function _LoadRec(){
	   $result = ($this->fBuffer = pg_fetch_assoc($this->fRS));
		if ($this->date_br === true){
		   $this->_DateBR();
		}
		if (!empty($this->OnLoadRec)){
		   $cmd = $this->OnLoadRec . '($this);';
		   eval($cmd);
		}
		return $result;
	}

    function _SQLDateFormat($SQLDate){
	  if (!strpos($SQLDate,"-")){
		  return substr($SQLDate,6,2) . "/" . substr($SQLDate,4,2) . "/" . substr($SQLDate,0,4);
	  }else{
         list($ano,$mes,$dia) = explode("-",$SQLDate);
         return "$dia/$mes/$ano";
	  }
    }

    function _SQLTimeStampBR($data){
	  if (!strpos($data,"-")){
		  $dt = substr($data,6,2) . "/" . substr($data,4,2) . "/" . substr($data,0,4);
		  $hr = substr($data,8,2) . ":" . substr($data,10,2) . ":" . substr($data,12,2);
		  return  "$dt $hr";
	  }else{
		 $data = str_replace(":","-",$data);
         list($ano,$mes,$dia,$hr,$mn,$sg) = explode("-",$SQLDate);
         return "$dia/$mes/$ano $hr:$mn:$sg";
	  }
	}
    //r: converte datas para o formado dd/mm/aaaa
    function _DateBR(){
	  $filed_list = $this->GetFieldNames();
	  foreach($filed_list as $fieldname){
	     $fDef = $this->db_fieldDef[$fieldname];
		 if (!empty($this->fBuffer[$fieldname])){
			 if ($fDef["type"] == "date"){
				$this->fBuffer[$fieldname] = $this->_SQLDateFormat($this->fBuffer[$fieldname]); 
			 }else if($fDef["type"] == "timestamp"){
				$this->fBuffer[$fieldname] = $this->_SQLTimeStampBR($this->fBuffer[$fieldname]); 
			 }
		 }
	  }
	}

    function _DecompSQL(){
	   $i = strpos($this->SQL, "FROM");
	   if ($i === false){$i = strpos($this->SQL, "from"); }
	   if ($i === false){
	      return "";
	   }else{
	      return substr($this->SQL,$i);
	   }
	}


    //r: Privado - Prepara SQL
	function _SQLPrepare(){
	  $this->fSQLo = $this->SQL;
      if ($this->paginado !== false) {
	     $a_sql  =  $this->_DecompSQL();
		 $tmpSQL  = "SELECT COUNT(0) AS all_rec $a_sql";
         $tmp_result = pg_query( $tmpSQL, $this->conexao );
		 if (($tmp_result !== false) && (pg_num_rows($tmp_result) > 0)) {
             $row = pg_fetch_assoc($tmp_result);
			 $this->fAllRecCount = $row["all_rec"];
             if ($this->limit > 0) {
				//r: Total de pagina
			    $this->fPageCount  = (int) ($this->fAllRecCount / $this->limit);
				if (($this->fAllRecCount % $this->limit) > 0) {
				   $this->fPageCount += 1;
				}if ($this->fAllRecCount > 0 & $this->fPageCount == 0){
                   $this->fPageCount += 1;
                }
				
				if ($this->currentPage > $this->fPageCount){
				   $this->currentPage = $this->fPageCount;
				}
				if ($this->currentPage < 1) {
				   $this->currentPage = 1;
				}
                //r: Registro inicial
                $this->fRecIni  = $this->limit * ($this->currentPage -1); 
			    $this->fSQLo    = sprintf("%s LIMIT %d, %d", $this->SQL, $this->fRecIni, $this->limit);
			 }else{
			    $this->fRecIni = 0;
			 }
		 }else{
		    $this->fAllRecCount = 0;
		 }
	     if ($tmp_result !== false) {pg_free_result($tmp_result);}
	  }  
	}

    function pg_fetch_field($RS,$idx){
       $result["table"] =
    }

    //r: Privado - Obtem informaoes dos campos
    
    function _getFieldInfo(){
	    $aresult = array();
		for ($i = 0; $i < pg_num_fields($this->fRS); $i++) {
>>>>>>>
>>>>>>> //Converter esta rotina: fazer a funo pg_fetch_field compativel com a do mysql
>>>>>>>
>>>>>>>
>>>>>>>
		  $campo = $this->pg_fetch_field($this->fRS,$i);
		  if ($campo !== false && $campo->name != "ZKU23SRS52_723876") {
		     $aresult[$campo->name] = array("table" => $campo->table,
				                            "max_length" => $campo->max_length,
				                            "not_null" => ($campo->not_null == 1),
				                            "primary_key" => ($campo->primary_key == 1),
				                            "unique_key" => ($campo->unique_key == 1),
				                            "multiple_key" => ($campo->multiple_key == 1),
				                            "numeric" => ($campo->numeric ==1),
				                            "blob" => ($campo->blob),
				                            "type" => $campo->type,
				                            "unsigned" => ($campo->unsigned == 1),
				                            "zerofill" => ($campo->zerofill == 1));
		  
		  } 
		}
	    
		$this->db_fieldDef = $aresult;
	}

    //r: Fecha consulta e libera recursos
    function Close() {
	   if ($this->fActive == true) {
	      pg_free_result($this->fRS);
		  $this->fRS         = false;
		  $this->fActive     = false;
          $this->fRecCount   = 0;
		  $this->fRecno      = 0;
		  unset($this->db_fieldDef);
		  $this->db_fieldDef = array();
	   }
	}

    //r: Abre a conssulta
    function Open(){
	   if ($this->fActive){
	      $this->Close();
	   }
	   if (($this->conexao == -1) || (empty($this->SQL))) {
          $this->lastError = ($this->conexao == -1)? "Identificador de conexo no informado.":"SQL no definida.";
	      return false;
	   }else{
		  $this->_SQLPrepare();
          $this->fRS = mysql_query( $this->fSQLo, $this->conexao );
		  $this->fRecno    = 0;
          if ($this->fRS === false){
			 $this->_PostgreErr(pg_last_error($this->conexao));
			 $this->fActive   = false;
			 $this->fRecCount = 0;
		  }else{
		     $this->fActive = true;
             $this->fRecCount   = pg_num_rows($this->fRS);
			 $this->_getFieldInfo();
			 $this->fSide = 0;
			 $this->_LoadRec();
		  }
	   }
	   return ($this->fRS !== false);
	}

   function ArrayResult(){
	  if ($this->_HaveData()){
   	     $ar = array();
	     $this->First();
	     while (!$this->Eof()){
		   array_push($ar, $this->fBuffer);
	       $this->Next();
	     }
	  }else{
	     $ar = array(1);
	  }
	  return $ar;
	}

	function RecordCount(){
	   return $this->fRecCount;
	}

    function RecNo(){
	   if ($this->fActive){
	      return $this->fRecno;
	   }else{
	      return false;
	   }
	}

    function GotoRecNo($recnum){
	   if ($this->_HaveData()){
          if ($recnum >= $this->fRecCount) {
	         $this->fSide = 2;
             $recnum = $this->fRecCount-1;
		  }else if ($recnum < 0) {
	         $this->fSide = 0;
		     $recnum = 0; 
		  }else{
	         $this->fSide = 1;
		  }

		  pg_result_seek($this->fRS, $recnum);
		  $this->_LoadRec();
		  $this->fRecno = $recnum;
       }else{ 
	      $this->fSide = 0;
	      return false;
	   }	   
	}

	function First(){
	   $this->GotoRecNo(0);
	}
	
	function Last(){
	   $this->GotoRecNo($this->fRecCount-1);
	}

    function Next(){
	   $this->GotoRecNo($this->fRecno + 1);
	}

    function Prior(){
	   $this->GotoRecNo($this->fRecno - 1);
	}

    function FieldValue($fieldname){ //r:db
	   if ($this->_HaveData()){
		  if (array_key_exists($fieldname,$this->fBuffer)) {
		     return $this->fBuffer[$fieldname];
		  }else{
		     return "";
		  }
	   }else{
         return "";	   
	   }
	}

    function GetARecord(){ //r:db
	   if ($this->_HaveData()){
	     return $this->fBuffer;
	   }else{
         return false;	   
	   }
	}

    function GetFieldNames(){
	   if ($this->_HaveData()){
         unset($this->fBuffer["ZKU23SRS52_723876"]);
	     return array_keys($this->fBuffer);
	   }else{
         return array();	   
	   }
	}

	function FieldCount() {
	   if ($this->_HaveData()){
	     return count($this->fBuffer);
	   }else{
         return false;	   
	   }
	}

    function FieldDef($fieldname){
	   if ($this->_HaveData()){
		  if (array_key_exists($fieldname,$this->db_fieldDef)) {
		     return $this->db_fieldDef[$fieldname];
		  }else{
		     return array();
		  }
	   }else{
         return array();	   
	   }
	}

    /*
	   Metodos para modo paginado
	*/

	//r: Total geral de registros (todos os registros de todas as pginas)
    function PgRecordCount(){
	  if ($this->paginado) {
	     return $this->fAllRecCount;
	  }else{
	     return $this->fRecCount;
	  }
	}

    function PageCount(){
	   return $this->fPageCount;
	}

	function PgStartRecord(){
	   return $this->fRecIni;
	}

	//r: Data 28/05/2008 - Envia um DeltaPackage para aplicaes desktop
	//r: ver o_mysqlquery.txt
	//r: encriptMode pode ser: 1 - SoftEncode, 2 Soft encode + Hex, 3 - S Hex
	function SendDelta($field_Sep,$rec_sep,$encriptMode = 2,$direct = true){
       if ($encriptMode < 2 || $encriptMode > 3){
          $encriptMode = 2;
       }

       if (empty($rec_sep) || $rec_sep == "!CRLF"){
          $rec_sep = "\n\t";
       }

       if (empty($field_Sep) || $field_Sep == "!TAB"){
          $field_Sep = "!".chr(9);
       }

       //r: Obtem a estrutura do resultset
       $aNomes = $this->GetFieldNames();
       $struc = array();
       foreach($aNomes as $k => $fnome){
          $fd = $this->db_fieldDef[$fnome];
          $linha  = "name=$fnome|type=$fd[type]|table=$fd[table]|blob=$fd[blob]|numeric=$fd[numeric]|";
          $linha .= "size=$fd[max_length]|unsign=$df[unsigned]|fill=$fd[zerofill]|pk=$fd[primary_key]|";
          $linha .= "uk=$fd[unique_key]|mk=$fd[multiple_key]|notNull=$fd[not_null]";
          // r: codificao
          $struc[] = encodeString($linha,$encriptMode);
       }

       //r: monta linha de header
       $sc = count($struc)+1;
       $fc = count($aNomes);
       $rc = $this->RecordCount();
       $err = $this->lastError;
       $errNum = (empty($err))? 0:1;
       $linha_zero = "strCount=$sc|fieldCount=$fc|recordCount=$rc|rowsaffect=$rc|errNum=$errNum|errStr=$err";
       //r: codifica a linha do header
       $linha_zero = encodeString($linha_zero,$encriptMode);

       //r: prepara pacote de retorno
       //r: Header e struct
       $buff = $linha_zero . $rec_sep;
       $i = 0; $j = count($struc)-1;
       foreach($struc as $k => $v){
          $buff .= $v;
          if ($i < $j){
             $buff .= $rec_sep;
          }
          $i += 1;
       }

       //r: Colocar a quebra de linha somente se houver pelomenos 1 registro a retornar
       if ($rc > 0){
          $buff .= $rec_sep;
       }
       
       //r: Dados
       while (!$this->Eof()){
          $linha = "";
          $i = 0;  $j = count($this->fBuffer)-1;
          //r: monta linha do resultset
          foreach($this->fBuffer as $k => $fv){
             //r: criptografa valor de cada campo
             $fv = encodeString($fv,$encriptMode);
             $linha .= $fv;
             if ($i < $j){
                $linha .= $field_Sep;
             }
             $i += 1;
          }
          $this->Next();
          //r: adiciona o novo registro (linha)
          if (!empty($linha)){
             $buff .= $linha;
             if (!$this->Eof()){
                $buff .= $rec_sep;
             }
          }
       }
       
       if ($direct){
          echo "\r\n<!--\r\n",$buff,"\r\n-->\r\n";
       }else{
          return "\r\n<!--\r\n$buff\r\n-->\r\n";
       }
    }

  } //r: Classe uMySQLQuery

  class uDbNavigator extends uObject {
	var $query;
	var $remoteLink;
	var $paramName;    //r: Nome do parametro que contem o nmero da pagina
    var $lnkClass;     //r: Nome de classe html para links (opcional)
    var $linkBarPages; //r: Nmero mximo de pginas a relacionar na barra de links (tipo google)
    var $url;          //r: URL alternativa para chamadas redirecionadas  (adicionado em 13/03)
    var $queryString;  //r: Query string opcional para chamadas redirecionadas (adicionado em 13/03)

	//r: Private
	var $extraQS;
    var $aimages;    //r: Array contedo lista de imagens para links (opcional)
    function uDbNavigator() {
	      $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uDbNavigator";
	      $classPath = (func_num_args() > 1)?  "uDbNavigator.".func_get_arg(1):"uDbNavigator";

		  $this->uObject($name,$classPath); //r: inherited
		  $this->query = false;
		  $this->paramName = "pgn";
		  $this->lnkClass  = "";
		  $this->extraQS   = "";
		  $this->url       = "";        //r: usrl do requisitante (remoto)
		  $this->queryString  = "";     //r: query string do requisitante (remoto)
		  $this->linkBarPages = 20;
		  $this->remoteLink   = false;  //r: trabalhar com link remoto

		  $this->aimages["first"] = array("enabled" => "","disabled"=>"");
		  $this->aimages["last"]  = array("enabled" => "","disabled"=>"");
		  $this->aimages["prior"] = array("enabled" => "","disabled"=>"");
		  $this->aimages["next"]  = array("enabled" => "","disabled"=>"");

	}

    function _GetLink($pgNum){
	   $result = (!$this->remoteLink)? $_SERVER["PHP_SELF"] : $this->url;
	   $pName  = $this->paramName;

	   $newParams = array();
	   array_push($newParams, "$pName=$pgNum");
	   
      $QSTR = (!$this->remoteLink)? $_SERVER['QUERY_STRING'] : $this->queryString;
	   if (!empty($QSTR)) {
		  $params = explode("&", $QSTR);
		  foreach ($params as $param) {
			if (stristr($param, $pName) == false) {
			  array_push($newParams, $param);
			}
		  }
	   }
	   if (count($newParams) != 0) {
		  $result .= "?" . htmlentities(implode("&", $newParams));
	   }

	   if (!empty($this->extraQS)){
         $result .= (strpos($result,"?") !== false)? "&":"?";
		   $result .= $this->extraQS;
	   }
	   return $result;
	}

    function _GetLnkClass(){
	   return (empty($this->lnkClass))? "":' class="'.$this->lnkClass.'"';
	}

    //r: Adicionar parmetros extras na URL
    function AddQueryStringParam($s){
	   $this->extraQS = $s;
	}

    //r: adiciona um par de imagens para link de navegao, ex: $obj->AddLnkImage("first",array("seta1_enabled.jpj","seta1_disabled.jpg"));
	//r: $lnk = ("first","prior","next","last")
	function AddLnkImage($lnk,$aLista){
	   if (array_key_exists($lnk,$this->aimages)){ 
	      $this->aimages[$lnk]["enabled"]  = $aLista[0];
	      $this->aimages[$lnk]["disabled"] = $aLista[1];
	   }
	}

    function LnkFirst(){
	   if ($this->query->currentPage > 1) {
	      return $this->_GetLink(1);
	   }else{
	      return "#";
	   }
	}

    function HrefFirst(){
	   $r = $this->LnkFirst();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}
    function LnkLast(){
	   if ($this->query->currentPage < $this->query->PageCount()) {
	       return $this->_GetLink($this->query->PageCount());
	   }else{
	      return "#";
	   }
	}
    function HrefLast(){
	   $r = $this->LnkLast();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function LnkPrior(){
	   if ($this->query->currentPage > 1) {
	      return $this->_GetLink($this->query->currentPage - 1);
	   }else{
   	      return "#";
	   }
	}
    function HrefPrior(){
	   $r = $this->LnkPrior();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function LnkNext(){
	   if ($this->query->currentPage < $this->query->PageCount()) {
	      return $this->_GetLink($this->query->currentPage + 1);
	   }else{
   	      return "#";
	   }
	}
    function HrefNext(){
	   $r = $this->LnkNext();
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function LnkToPage($npage){
	   if (($npage > 0) && ($npage <= $this->query->PageCount() )) {
	      return $this->_GetLink($npage);
	   }else{
   	      return "#";
	   }
	}
    function HrefToPage($npage){
	   $r = $this->LnkToPage($npage);
	   return ($r != "#")? '<a href="'.$r.'"'.$this->_GetLnkClass().'>':"";
	}

    function GetNavArray(){
	   $result = array();
       $result["lnk_first"]   = "";  //r: Primeira pgina
	   $result["lnk_first_f"] = "";  //r: Fecha tag
	   $result["lnk_prior"]   = "";  //r: Pagina anterior
	   $result["lnk_prior_f"] = "";  //r: Fecha tag
	   $result["lnk_next"]    = "";  //r: Proxima Pagina
	   $result["lnk_next_f"]  = "";  //r: Fecha tag
	   $result["lnk_last"]    = "";  //r: Ultima Pagina
	   $result["lnk_last_f"]  = "";  //r: Fecha tag

	   $result["current_page"] = $this->query->currentPage;    //r: Pagina corrente
	   $result["page_count"]   = $this->query->PageCount();    //r: Total de pginas possiveis
	   $result["start_rec"]    = $this->query->PgStartRecord(); //r: nmero real do registro inicial da pagina
	   $result["last_rec"]     = $this->query->PgStartRecord() + (($this->query->RecordCount() > 0)? $this->query->RecordCount()-1:0);
	   $result["record_count"] = $this->query->PgRecordCount(); //r: Total geral de registros (todas as paginas)
	   $result["page_records"] = ($this->query->paginado)? $this->query->limit:"Todos";

       if ($this->query->RecordCount() > 0){
	      $result["start_rec"]    += 1;
	      $result["last_rec"]     += 1;
       }
      
	   //r: Monta os links
	   $aux = $this->HrefFirst();
	   if (!empty($aux)){ $result["lnk_first"] = $aux; $result["lnk_first_f"] = "</a>";}
       $aux = $this->HrefLast();
	   if (!empty($aux)){ $result["lnk_last"] = $aux; $result["lnk_last_f"] = "</a>";}
      $aux = $this->HrefPrior();
	   if (!empty($aux)){ $result["lnk_prior"] = $aux; $result["lnk_prior_f"] = "</a>";}
      $aux = $this->HrefNext();
	   if (!empty($aux)){ $result["lnk_next"] = $aux; $result["lnk_next_f"] = "</a>";}

       //r: Relaciona as imagens correspondetes
       $result["img_first"] = empty($result["lnk_first"])? $this->aimages["first"]["disabled"]:$this->aimages["first"]["enabled"];
	   $result["img_last"]  = empty($result["lnk_last"])?  $this->aimages["last"]["disabled"]:$this->aimages["last"]["enabled"];
	   $result["img_prior"] = empty($result["lnk_prior"])? $this->aimages["prior"]["disabled"]:$this->aimages["prior"]["enabled"];
	   $result["img_next"]  = empty($result["lnk_next"])?  $this->aimages["next"]["disabled"]:$this->aimages["next"]["enabled"];

      //r: Monta link bar
      $this->linkBarPages = ($this->linkBarPages >= 15)? $this->linkBarPages:20;
      
      $cr  = $result["current_page"];
      $pg  = ($cr > 10)?  ($cr-10):1;
      $pgf = $pg + $this->linkBarPages;

      $link_bar = "";
      while ($pg <= $pgf){
        if ($pg != $cr){
           $lnk = $this->LnkToPage($pg);
           if ($lnk != "#"){
              $link_bar .= ' <a href="'.$lnk.'">'."$pg</a> ";
           }
        }else{
           $link_bar .= " $pg ";
        }
        $pg++;
      }
      $result["link_bar"] = $link_bar;

      return $result;
	}
	

  } //r: classe uDbNavigate
?>
