<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004
	 ---------------------------------------------------------------------------
  */

  global $REQUEST;
  

  class uRequest {
     var $scriptName;     //r: Nome e path (relativo) do arquivo (cript) php em execuo
     var $arrayParams;    //r: Array contendo a lista de argumentos passados via linha de comando ou GET
     var $paramCount;     //r: Contem o nmero de parmetros passados por linha de comando ou GET
     var $cgiVersion;     //r: Nmero de verso do CGI que o servidor esta executando. ex "CGI/1.1"
     var $serverName;     //r: Nome do computador (servidor) onde o script esta rodando.
     var $serverSoftware; //r: A string de identificao do servidor, fornecida nos headers quando respondendo a requests
     var $httpVersion;    //r: Numero de verso do protocolo pelo qual a pagina foui requerido ex. "HTTP/1.0"
     var $metodo;         //r: Contem o metodo de request utilizado para acesso (GET,POST,HEAD,PUT)
     var $queryString;    //r: A query string (string de solicitao), se houver, pela qual a pgina foi acessada
     var $documentRoot;   //r: O diretrio raiz sob onde o script atual  executado, como definido no arquivos de configurao do servidor
     var $charSet;        //r: O contedo do header Accept-Charset: da requisio atual, se houver. Exemplo: 'iso-8859-1,*,utf-8'.
     var $calledFrom;     //r: URL de origem, de onde o script foi chamado se houver (no confivel)
     var $browseInfo;     //r: Informaes do browser que fez o request
     var $remoteIp;       //r: O endereo IP de onde o usurio est visualizado a pgina atual.
     var $remoteName;     //r: O nome do host que o usurio utilizou para chamar a pgina atual. O DNS reverso (lookup) do REMOTE_ADDR do usurio
     var $remotePort;     //r: A porta TCP na mquina do usurio utilizada para comunicao com o servidor web.
     var $scriptFileName; //r: O caminho absoluto o script atualmente em execuo
                          //r:    Nota: Se o script for executado pela CLI com um caminho relativo, como file.php ou ../file.php,
                          //r:          scriptFileName ir conter o caminho relativo especificado pelo usurio
     var $realPath;       //r: Contem o path real para o arquivo de script atual apos todas as conversoes (virtual-to-real)
     var $selfURL;        //r: Contm o caminho completo do script atual. til para pginas que precisam apontar para elas mesmas (dinamicamente).
     var $requestString;  //r: O URI fornecido para acessar a pgina atual, por exemplo, '/index.html'.
     
     /*
      *  Quando executando sob o Apache como mdulo e fazendo autenticao HTTP
      */
     var $authType;       //r: tipo de autenticao utilizado
     var $authUser;       //r: username fornecido pelo usurio
     var $authPassword;   //r: senha fornecida pelo usurio
     
     function uRequest(){
        $this->scriptName     = $_SERVER["PHP_SELF"];
        $this->arrayParams    = $_SERVER["argv"];
        $this->paramCount     = $_SERVER["argc"];
        $this->cgiVersion     = $_SERVER["GATEWAY_INTERFACE"];
        $this->serverName     = $_SERVER["SERVER_NAME"];
        $this->serverSoftware = $_SERVER["SERVER_SOFTWARE"];
        $this->httpVersion    = $_SERVER["SERVER_PROTOCOL"];
        $this->metodo         = $_SERVER["REQUEST_METHOD"];
        $this->queryString    = $_SERVER["QUERY_STRING"];
        $this->documentRoot   = $_SERVER["DOCUMENT_ROOT"];
        $this->charSet        = $_SERVER["HTTP_ACCEPT_CHARSET"];
        $this->calledFrom     = $_SERVER["HTTP_REFERER"];
        $this->browseInfo     = $_SERVER["HTTP_USER_AGENT"];
        $this->remoteIp       = $_SERVER["REMOTE_ADDR"];
        $this->remoteName     = $_SERVER["REMOTE_HOST"];
        $this->remotePort     = $_SERVER["REMOTE_PORT"];
        $this->scriptFileName = $_SERVER["SCRIPT_FILENAME"];
        $this->realPath       = $_SERVER["PATH_TRANSLATED"];
        $this->selfURL        = $_SERVER["SCRIPT_NAME"];
        $this->requestString  = $_SERVER["REQUEST_URI"];
        $this->authType       = $_SERVER["AUTH_TYPE"];
        $this->authUser       = $_SERVER["PHP_AUTH_USER"];
        $this->authPassword   = $_SERVER["PHP_AUTH_PW"];
     }
  }

  $REQUEST = new uRequest;
?>
