<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004 
	 ---------------------------------------------------------------------------
  */

  global $active_section;
  global $USession;
  
  $active_section = isset($_SESSION["ulib_started_session"]);
  $USession = false;
  
  function IniciaSessao($new_cache_exptire = false){
    global $USession;
    if ($USession === false){
       $USession = new uSession($new_cache_exptire);
    }
    return $USession->Self();
  }

  function SRead($varName){
     if (isset($_SESSION[$varName])){
        return $_SESSION[$varName];
     }else{
       return false;
     }
  }

  function SWrite($varName,$value){
     $_SESSION[$varName] = $value;
  }

  class uSession{

	  function uSession($new_cache_exptire = false){
		   $this->Initialize($new_cache_exptire);
	  }

      //r: Cria um novo objeto sesso
      function Create($new_cache_exptire = false){
  	     global $active_section;
	     global $USession;
		 if (!$active_section){
	        return new uSession($new_cache_exptire); 
		 }else{
		    return $USession->Pointer();
		 }
	  }

      //r: Inicializa sesso - modo seguro
      function Initialize($new_cache_exptire = false){
		  global $active_section;
		  if (!$active_section){
			 if ($new_cache_exptire !== false){
			    session_cache_expire($new_cache_exptire);
			 }
          @session_start();
          $_SESSION["ulib_started_session"] = true;
	   	 $active_section = true;
		  }
	  }

      //r: Retorna um ponteiro para o objeto
      function Self(){
	     return $this;
	  }

      //r: No guardar no cahe do cliente
      function NoCache(){
	      session_cache_limiter('nocahe');
		  return session_cache_limiter();
	  }

      //r: Liberar para guardar no cahe do cliente
	  Function PublicCache(){
	      session_cache_limiter('public');
		  return session_cache_limiter();
	  }

      //r: Guardar no cahe do cliente com restries
	  Function PrivateCache(){
	      session_cache_limiter('private_no_expire');
		  return session_cache_limiter();
	  }

      //r: Retorna o estado da seo (Ativa ou no)
      function Active(){
	     global $active_section;
		 return $active_section;
	  }

      //r: Verifica se uma varivel de sesso est definida
      function VarSet( $varName ){
	     return isset($_SESSION[$varName]);
	  }

      //r: L valor de varivel
      function GetValue($varName){
		 if (isset($_SESSION[$varName])) {
	        return $_SESSION[$varName];
		 }else{
		    return "";
		 }
	  }

      //r: Seta valor de varivel
	  function SetValue($varName,$varVal){
	    $_SESSION[$varName] = $varVal;
	  }

      //r: L ou escreve valor de varivel de sesso
	  function ValueOf($varName,$varVal = "<[vazio_empty_zero]>"){
	     if ($varVal == "<[vazio_empty_zero]>") {
		    return $_SESSION[$varName];
		 }else{
		    $_SESSION[$varName] = $varVal;
		 }
	  }

      //r: Libera uma varivel de seo.
	  function Release($varName){
	     unset($_SESSION[$varName]);
	  }

      //r: Libera todas as variveis de sesso
	  function ReleaseAll(){
	     unset($_SESSION);
	  }
	  
	  function Close(){
        unset($_SESSION);
     }
  }
?>
