<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 5.0.1
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004
      Atualizada em: 15/06/2011
	 ---------------------------------------------------------------------------
  */


global $lib_path;
global $ulib_ver;
global $ulib_data;
global $ulib_build;

/* Localizao relativa da biblioteca
   $lib_path deve ser definido no arquivo mestre se estiver numa pasta diferente de /_ulib_
*/
$lib_path   = (isset($lib_path))?    $lib_path:$_SERVER["DOCUMENT_ROOT"]."/_ulibb_";
$ulib_ver   = "6.0.1";
$ulib_build = 1;  //r: nmero da build, incrementar a cada alterao
$ulib_data  = "16/05/2013";

define("ULIB_VERSION","$ulib_ver.$ulib_build de $ulib_data");

//r: Funes auxiliares
function IsOfClass(&$obj,$className){
  return (strpos(strtoupper($obj->classPath),strtoupper($className)) === true);
}

function IsClass(&$obj,$className){
  $className = strtoupper($className);
  $tmp = strtoupper($obj->classPath);
  $j = strrpos($tmp,$className);
  if ($j === false) {
     return false;
  }else{
     $tmp = substr($tmp,$j);
	 return ($className == $tmp);
  }
}

function ChekBuildTo($build){
  global $ulib_build;

  if ($ulib_build < $build){
	    $called = $_SERVER["PHP_SELF"];
		echo "<b>Alerta !! <br>Verso da biblioteca anterior ao exigido pelo cdiogo em </b><br>",$called;
  }
}

function FreeObject(&$obj_ref){
  $obj_ref->Free($obj_ref);
}

class uObject {
   //r: Propriedades
   var  $name;
   var  $classPath;
   var  $tag;
   //r: Eventos
   var  $onDestroy;
   //r: Eventos internos
   var  $onFree;
   function uObject() {
	  $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uObject";
	  $classPath = (func_num_args() > 1)?  "uObject.".func_get_arg(1):"uObject";
	  $this->name       = $name;
      $this->classPath  = $classPath;
	  $this->onDestroy  = "";
	  $this->onFree     = "";
	  $this->tag        = 0;
   }

   function Free(&$obj_ref){
	  if ($this->onDestroy !== "") {
	    $cmd = $this->onDestroy . '($this);';
		eval($cmd);
	  }

	  if ($this->onFree !== "") {
	    $cmd = $this->onFree . '();';
		eval($cmd);
	  }

      $obj_ref = false;
   }
}


?>
