<?php
/*
 * Programa    : MySQL
 * Objetivo    : Conexo com o MySQL - similar ao java
 * Programador : Alexandre P. Trindade
 * Data Incio : 13 de junho de 2003 - sexta-feira
 * Alterado em : 09/06/2011
 
 
   Historico de versoes
   --------------------------------------------------------------------------------------
   Ver. 0.2 - 09/06/2011  - Alexandre P. Trindade
           Implementado suporte a transao
      Propriedades:
           inTransaction  <bool>  Indeica se h ou no uma transao ativa
           
      Metodos:
         SetAutoCommit()           - Ativa/desativa modo transacional
         
         StatrtTransaction()       - Inicia uma transao
         
         Commit()                  - Confirma todas as modificaes da transao atual
         
         RollBack()                - Cancela todas as modificaes da transao atual
         
   --------------------------------------------------------------------------------------
   Var 0.1 - 13/06/2003
 */
 
class  MySQLConnection {
	var $conn       = null;
	var $msg	    = "";
	var $db         = "";
	var $lastError  = "";
	var $autoCommit = false;
    var $inTransaction;

	function MySQLConnection($host, $user, $pass, $db) {
		    $this->conn = @mysql_connect($host, $user, $pass) or die("MYSQL-Erro na conexo com o banco: " . mysql_error());
        	mysql_select_db($db) or die("MYSQL-Database '$db' no foi encontrado.");
        	$this->db   = $db;
        	$this->executeUpdate("BEGIN");
        	$this->inTransaction = false;
        	$this->autoCommit = false;
        	$this->lastError = false;
	}

	function executeUpdate($sql) {
		$nr = mysql_query($sql, $this->conn) or die("MYSQL-Erro no Update [$sql]".mysql_error());
		return mysql_affected_rows();
	}
   
    function execSQL($sql){
       $nr = mysql_query($sql, $this->conn);
       if (!$nr){
          $this->lastError = mysql_error();
          return false;
       }else{
          return true;
       }
    }
   
    function close(){
	   mysql_close($this->conn);
	}
	
	function SetAutoCommit($lModo=false){
         if ($lModo == true){
            $sql = "SET AUTOCOMMIT=1";
         }else{
            $sql = "SET AUTOCOMMIT=0";
         }
         
         $r = mysql_query($sql, $this->conn);
         if (!$r){ die("MYSQL-Sql Error [$sql]".mysql_error()); }
         
         if (!$lModo){
             // ativa modo transacional
             $sql = "SET SESSION TRANSACTION ISOLATION LEVEL READ COMMITTED";
             $i = mysql_query($sql,$this->conn);
             if (!$i){
                die("MYSQL-Sql Error [$sql]".mysql_error());
             }
         }

         if ($r){ $this->autoCommit = $lModo; }
         return $r;
    }
    
    function StartTransaction(){
        if (!$this->inTransaction){
            $sql = "START TRANSACTION";
            $this->inTransaction = mysql_query($sql, $this->conn);

            if (!$this->inTransaction){
               $this->lastError = mysql_error();
            }
        }
        return $this->inTransaction;
    }
    
    function Commit(){
        $result = false;
        if ($this->inTransaction){
            $sql = "COMMIT";
            $result = mysql_query($sql, $this->conn);
            $this->inTransaction = !$result;
            
            if (!$this->inTransaction){
               $this->lastError = mysql_error();
            }
        }
        return $result;
    }
    
    function RollBack(){
        $result = false;
        if ($this->inTransaction){
            $sql = "ROLLBACK";
            $result = mysql_query($sql, $this->conn);
            $this->inTransaction = !$result;
            
            if (!$this->inTransaction){
               $this->lastError = mysql_error();
            }
        }
        return $result;
    }
}

?>
