<?php
/*
 * Programa    : Padrao
 * Objetivo    : Estende as funes de REQUEST, SESSION, COOKIE, HEADER
 * Programador : Joo Gustavo Ferreira Farias
 * Data Incio : 09 de julho de 2003 - quarta-feira
 * Data Trmino: 10 de julho de 2003 - quinta-feira
 */

function RError($msg){
   die($msg);
}

function _get_globals($var,$default=""){
   if (isset($_POST[$var])){
      return $_POST[$var];
   }else if (isset($_GET[$var])){
      return $_GET[$var];
   }else{
      return $default;
   }
}

function _get_get($var,$default=""){
   return isset($_GET[$var]) ? $_GET[$var] : $default;
}

function _get_post($var,$default=""){
    return isset($_POST[$var]) ? $_POST[$var] : $default;
}

function getPar($var,$default="",$orig="globals") {
    if ($orig=="globals"){
       return _get_globals($var,$default);
    }else if ($orig == "get"){
       return _get_get($var,$default);
    }else if ($orig == "post"){
       return _get_post($var,$default);
    }else{
       RError("RParams Erro: Origem invlida '$orig'");
    }
}


class RParams {
    static function get($var,$default="",$orig="globals") {
       return getPar($var,$default,$orig);
    }
    static function get_t($var,$default="",$orig="globals") {
        return trim( getPar($var,$default,$orig) );
    }
    static function get_tu($var,$default="",$orig="globals") {
        return strtoupper(trim(getPar($var,$default,$orig)));
    }
    static function get_tl($var,$default="",$orig="globals") {
        return strtolower(trim( getPar($var,$default,$orig) ));
    }
    static function get_ts($var,$default="",$orig="globals") {
        $var = trim(getPar($var,$default,$orig));
        return ereg_replace("[[:space:]]+", " ", $var);
    }

    static function get_tus($var,$default="",$orig="globals") {
        $var = strtoupper(trim(getPar($var,$default,$orig)));
        return ereg_replace("[[:space:]]+", " ", $var);
    }

    static function get_tls($var,$default="",$orig="globals") {
        $var = strtolower(trim(getPar($var,$default,$orig)));
        return ereg_replace("[[:space:]]+", " ", $var);
    }

    static function get_tus_az($var,$default="",$orig="globals") {
        $var = strtoupper(trim(getPar($var,$default,$orig)));
        $var = ereg_replace("[[:space:]]+", " ", $var);
        $var = ereg_replace("[]", "A", $var);
        $var = ereg_replace("[]", "E", $var);
        $var = ereg_replace("[]", "I", $var);
        $var = ereg_replace("[]", "O", $var);
        $var = ereg_replace("[]", "U", $var);
        $var = ereg_replace("[]", "C", $var);
        $var = ereg_replace("[^A-Z' ]", "", $var);
        return $var;
   }

   static  function get_tus_azn($var,$default="",$orig="globals") {
        $var = strtoupper(trim(getPar($var,$default,$orig)));
        $var = ereg_replace("[[:space:]]+", " ", $var);
        $var = ereg_replace("[]", "A", $var);
        $var = ereg_replace("[]", "E", $var);
        $var = ereg_replace("[]", "I", $var);
        $var = ereg_replace("[]", "O", $var);
        $var = ereg_replace("[]", "U", $var);
        $var = ereg_replace("[]", "C", $var);
        $var = ereg_replace("[^A-Z0-9' ]", "", $var);
        return $var;
   }

}



class Request {
    function get($var) {
        return isset($GLOBALS["HTTP_GET_VARS"][$var]) ? $GLOBALS["HTTP_GET_VARS"][$var] : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? $GLOBALS["HTTP_POST_VARS"][$var] : "");
    }
    function get_t($var) {
        return isset($GLOBALS["HTTP_GET_VARS"][$var]) ? trim($GLOBALS["HTTP_GET_VARS"][$var]) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? trim($GLOBALS["HTTP_POST_VARS"][$var]) : "");
    }
    function get_tu($var) {
        return isset($GLOBALS["HTTP_GET_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_GET_VARS"][$var])) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_POST_VARS"][$var])) : "");
    }
    function get_tl($var) {
        return isset($GLOBALS["HTTP_GET_VARS"][$var]) ? strtolower(trim($GLOBALS["HTTP_GET_VARS"][$var])) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? strtolower(trim($GLOBALS["HTTP_POST_VARS"][$var])) : "");
    }
    function get_ts($var) {
        $var = isset($GLOBALS["HTTP_GET_VARS"][$var]) ? trim($GLOBALS["HTTP_GET_VARS"][$var]) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? trim($GLOBALS["HTTP_POST_VARS"][$var]) : "");
        return ereg_replace("[[:space:]]+", " ", $var);
    }

    function get_tus($var) {
        $var = isset($GLOBALS["HTTP_GET_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_GET_VARS"][$var])) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_POST_VARS"][$var])) : "");
        return ereg_replace("[[:space:]]+", " ", $var);
    }

    function get_tls($var) {
        $var = isset($GLOBALS["HTTP_GET_VARS"][$var]) ? strtolower(trim($GLOBALS["HTTP_GET_VARS"][$var])) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? strtolower(trim($GLOBALS["HTTP_POST_VARS"][$var])) : "");
        return ereg_replace("[[:space:]]+", " ", $var);
    }

    function get_tus_az($var) {
        $var = isset($GLOBALS["HTTP_GET_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_GET_VARS"][$var])) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_POST_VARS"][$var])) : "");
        $var = ereg_replace("[[:space:]]+", " ", $var);
        $var = ereg_replace("[]", "A", $var);
        $var = ereg_replace("[]", "E", $var);
        $var = ereg_replace("[]", "I", $var);
        $var = ereg_replace("[]", "O", $var);
        $var = ereg_replace("[]", "U", $var);
        $var = ereg_replace("[]", "C", $var);
        $var = ereg_replace("[^A-Z' ]", "", $var);
        return $var;
   }

    function get_tus_azn($var) {
        $var = isset($GLOBALS["HTTP_GET_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_GET_VARS"][$var])) : (isset($GLOBALS["HTTP_POST_VARS"][$var]) ? strtoupper(trim($GLOBALS["HTTP_POST_VARS"][$var])) : "");
        $var = ereg_replace("[[:space:]]+", " ", $var);
        $var = ereg_replace("[]", "A", $var);
        $var = ereg_replace("[]", "E", $var);
        $var = ereg_replace("[]", "I", $var);
        $var = ereg_replace("[]", "O", $var);
        $var = ereg_replace("[]", "U", $var);
        $var = ereg_replace("[]", "C", $var);
        $var = ereg_replace("[^A-Z0-9' ]", "", $var);
        return $var;
   }

}

class Header {
    function location($caminho) {
        header("Location: ".$caminho);
    }

    function refresh($query="") {
        header("Location: "."http://".$GLOBALS["_SERVER"]["HTTP_HOST"].$GLOBALS["_SERVER"]["PHP_SELF"]."?".$query);
    }

    function noCache() {
        header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
        header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
        header("Cache-Control: no-store, no-cache, must-revalidate");  //r: HTTP/1.1
        header("Cache-Control: post-check=0, pre-check=0", false);
        header("Pragma: no-cache"); //r: HTTP/1.0
    }
}

function get_Date() {
        $dd = @date("d");
		$mm = @date("n");
		$yy = @date("Y");
		$ds = @date("w");
		$hs = @date("H:i\h");
		$mes  = array("janeiro","fevereiro", "maro", "abril", "maio", "junho", "julho", "agosto", "setembro", "outubro","novembro","dezembro");
		$dsem = array("Domingo", "Segunda-feira", "Tera-feira", "Quarta-feira", "Quinta-feira", "Sexta-feira", "Sbado");
		return $dsem[$ds].", ".$dd." de ".$mes[$mm-1]." de ".$yy."-$hs";
}

$_SYSDATE_ = get_Date();

function space2nbsp($var) {
        return ereg_replace("[ ]{2}", "&nbsp;&nbsp;", $var);
}

function noRepeat($var) {
    $var = preg_replace("/([A-Za-z])\\1{1,}/","\\1\\1", $var);
    $var = preg_replace("/^([A-Za-z])\\1$/","", $var);
    return $var;
}

class File {
    var $name="";
    var $ext ="";
    var $type="";
    var $size=0;
    var $tmp_name="";
    var $error="";
    var $url="";

    /*  Construtor da classe
     *  @param $nome: Passa nome do campo no formulrio correspondente ao arquivo enviado.
     */
    function File($nome) {
        if (isset($_FILES[$nome])) {
            $this->name     = $_FILES[$nome]['name'];
            $this->type     = $_FILES[$nome]['type'];
            $this->size     = $_FILES[$nome]['size'];
            $this->tmp_name = $_FILES[$nome]['tmp_name'];
            $this->error    = $_FILES[$nome]['error'];
            preg_match("/([a-z0-9_-]*)(\.[a-z]{3,4}$)/", $this->name, $match) ;
            if (isset($match[1])) {
               $this->ext      = $match[2];
            }
        } else {
            $this->url      = $nome;
            preg_match("/\/([a-z0-9_-]*)(\.[a-z]{3,4}$)/", $nome, $match) ;
            if (isset($match[1])) {
               $this->name     = $match[1].$match[2];
               $this->ext      = $match[2];
            }
        }
    }

    /* Move o arquivo recebido da pasta UpLoadTemp para o local desejado
     *
     */
    function upload($destino, $novonome="", $auto=0) {
        if ($this->name == "") return false;
        if ($novonome=="") {
            $novonome = $this->name;
        }
        if ($auto==0){
            $uploadfile = $destino. $novonome.$this->ext;
         			$this->name = $novonome.$this->ext;
        } else {
            $data = date("Y_m_d_H_i_s");
            $uploadfile = $destino."/arq".$data.$this->ext;
            $this->name = "arq".$data.$this->ext;
        }


        if (move_uploaded_file($this->tmp_name, $uploadfile)) {
            return true;
        } else {
            print "Possvel ataque!  Informaes do debug:\n";
            print_r($_FILES);
            return false;
        }
        return true;
    }

    function getFile($destino, $novonome="", $auto=0) {
        if ($novonome=="") {
            $novonome = $this->name;
        }
        if ($auto==0){
            $file = $destino. $novonome.$this->ext;
			$this->name = $novonome.$this->ext;
        } else {
            $data = date("Y_m_d_H_i_s") ;
            $file = $destino."/arq".$data.$this->ext;
            $this->name = "arq".$data.$this->ext;
        }
        $fo = fopen($this->url,"rb");
        $fd = fopen($file,"wb");
        while ($data = fread($fo,1024)) {
            fwrite($fd,$data);
        }
        fclose($fd);
        fclose($fo);
		return TRUE;
    }

    function getName() {
        return $this->name;
    }
}


?>
