<?php
  /*
     Funes para obteno de notcias de reveistas e jornais 
	         para publicao das chamadas.
     Autor.: Alexandre P. Trindade
     Inicio: 20/10/2005 
     Copyright Uniware Informtica
  */


  /* 
    Obtem as ultimas notcias publicadas pela Revista Cafeicultura
	www.revistacafeicultura.com.br
  */
  function noticias_revistacafeicultura($qtd = 10,$alt_path = ""){
    $tiker = "http://www.revistacafeicultura.com.br/disp_noticias.php";  //r: URL do fornecedor da lista
	 if (!empty($alt_path)) { $tiker = $alt_path; }
	 $result = array();
	 $aux = @file($tiker);  //r: Obtem a lista
    $ini = false; $fim = false;
    if (is_array($aux) && count($aux) > 0) {
 	    foreach($aux as $k => $v){
	      if (strpos( strtolower($v),"<news>") !== false){
		     $ini = true;
		   }else if (strpos( strtolower($v),"</news>") !== false){
		     $fim = true;
		   }else if ($ini && !$fim && count($result) < $qtd){
		     $reg = array();
		     $reg = explode('";',$v);
		     if (count($reg) == 3){
		        for($i=0;$i < 3;$i++){
				    $reg[$i] = str_replace('"',"",$reg[$i]);
				    $reg[$i] = str_replace('\n',"",$reg[$i]);
			     }
              $result[] = $reg;
		     }
		  }
	   }
    }
	 return $result;
  }

  /*
     Enfoque Informaes Financeiras
	 Noticias
  */
  function noticias_Enfoque_InfoFinanc($qtd = 10,$alt_path = ""){
     $tiker = "http://quotes.enfoque.com.br/cafedocerrado/noticias.txt";  //r: URL do fornecedor da lista
	 if (!empty($alt_path)) { $tiker = $alt_path; }
	 $result = array();
	 $aux = array_slice( @file( $tiker ), 1, $qtd+1 );  //r: Obtem a lista
     
	 if (is_array($aux) && count($aux) > 0){
  	    $reg = array();
	    foreach($aux as $k => $v ){
	      $reg = explode(";",$v);
		   $result[] = $reg;
	    }
     }
     return $result;
  }

  /*
     Enfoque Informaes Financeiras
	 Cotao do Dolar
  */
  function US_dolar_cotacao_enfoqueIF($alt_path = ""){
     $tiker = "http://quotes.enfoque.com.br/cafedocerrado/cotacoes.txt";  //r: URL do fornecedor
	 if (!empty($alt_path)) { $tiker = $alt_path; }
	 $result = array();
	 $aux = array_slice( @file( $tiker ), 1 );
    if (is_array($aux) && count($aux) > 0){
	    $reg = array();
	    foreach($aux as $k => $v ){
		   //r: codigo;descricao;compra;venda;hora;data
	      $reg = explode(";",$v);
		   if (count($reg) > 1){ $reg[1] = ucwords(strtolower($reg[1])); }
		   $result[] = $reg;
	    }
    }
	 
    return $result;
  }
?>
