<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004
	 ---------------------------------------------------------------------------

	 Procedimentos para controle de sesso
  */
  define('LOG_FLAG',"LOGIN");       //r: Nome da varivel default para flag de login (true/false)
  define('LOG_DATA',"LOGIN_INFO");  //r: Entrada para dados do login - informaes do usurio (array)
  define('SESS_DATA',"DEFAULT_SESSION_DATA");  //r: Dados genricos da sesso (no ligados a login)

  session_start();

  function LogUser($log_data = ""){
     $_SESSION[LOG_FLAG] = true;
	  $_SESSION[LOG_FLAG] = true;
	  $_SESSION[LOG_DATA] = $log_data;
	  return Logged();
  }

  Function LogOut(){
     if (Logged()){
	    $_SESSION[LOG_FLAG] = false;
		 $_SESSION[LOG_DATA] = array();
	 }
  }

  function Logged(){
     return isset($_SESSION[LOG_FLAG]) ? $_SESSION[LOG_FLAG] : false;
  }

  function LogInfo(){
	 if (Logged()) {
        return $_SESSION[LOG_DATA];
	 }else{
	    return false;
	 }
  }

  function SetSessionData($data_sess = ""){
    if (!empty($data_sess)){
       $_SESSION[SESS_DATA] = $data_sess;
       return true;
    }else{
      return false;
    }
  }

  function SessionHasData(){
     return isset($_SESSION[SESS_DATA]);
  }

  function GetSessionData(){
     if (SessionHasData()){
        return $_SESSION[SESS_DATA];
     }else{
        return false;
     }
  }

  //r: Variaveis livres

  function SessionHasPvData($varName){
     return isset($_SESSION[$varName]);
  }

  function SetSessionPvData($varName, $data_sess = ""){
    if (!empty($data_sess)){
       $_SESSION[$varName] = $data_sess;
       return true;
    }else{
      return false;
    }
  }

  function GetSessionPvData($varName){
     if (SessionHasPvData($varName)){
        return $_SESSION[$varName];
     }else{
        return false;
     }
  }

  function KillSessionPvData($varName){
     if (isset($_SESSION[$varName])){
        unset($_SESSION[$varName]);
     }
  }

  function freeSession(){
    $_SESSION = array();
    session_destroy();
  }
?>
