<?php
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
      Inicio: 15/09/2004 
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/o_files.php"); 
  /*{$NC-}*/
  /*{$CB+}
  uses("o_files");
  {$CB-}*/

  class uCsvFile extends uFile {
	 var $fieldSep;
	 var $useFieldNames;
	 var $fieldCount;
     var $f_fieldList;

	  function uCsvFile(){
	      $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-uCsvFile";
	      $classPath = (func_num_args() > 1)?  "uCsvFile.".func_get_arg(1):"uCsvFile";

		  $this->uFile($name,$classPath); //r: inherited

          $this->f_fieldList   = array();
		  $this->fieldSep      = ";";
		  $this->useFieldNames = false;
		  $this->fieldCount    = 0;
	  }

      function ClearFieldList(){
	     $this->f_fieldList   = array();
	  }

      function AddFieldDef($field_name,$default_value){
	    $this->f_fieldList[count($this->f_fieldList)] = array("fieldName" => $field_name,"defaultValue" => $default_value);
	  }

      function _ConvertToFieldDef($buff){
	     $a_result = array();
		 //r: Inicializa todos os campos com os valores default (quando houver).
		 $afld = $this->f_fieldList;
		 $nomecampos = array();
		 foreach($afld as $field) {
		   $a_result[$field["fieldName"]] = $field["defaultValue"];
		   $nomecampos[count($nomecampos)] = $field["fieldName"];
		 }

		 $n = 0; $sep = $this->fieldSep; $this->fieldCount = 0;
		 while ((strlen($buff) > 0) && ($n < count($a_result))) {
		   $i = strpos($buff, $sep);
		   if ($i === false ) {
			  $s = trim($buff);
			  $a_result[$nomecampos[$n]] = $s; 
			  $buff = "";
		   }else if ($i == 0) {
			  $a_result[$nomecampos[$n]] = ""; //r: campo vazio;
			  $buff = substr($buff,1);
		   }else if ($i > 0) {
			  $s = trim(substr($buff,0,$i));
			  $a_result[$nomecampos[$n]] = $s;
			  $buff = substr($buff,$i+1);
		   }
		   $n += 1;
		   $this->fieldCount += 1;
		 } 
		 return $a_result;
	  }

      function _ConvertToIdxArray($buff){
	     $a_result = array();
		 $n = 0; $this->fieldCount = 0;
		 while (strlen($buff) > 0) {
		   $i = strpos($buff, ";");
		   if ($i === false ) {
			  $s = trim($buff);
			  $s = str_replace("'","",$s);
			  $a_result[$n] = $s; 
			  $buff = "";
		   }else if ($i == 0) {
			  $a_result[$n] = ""; //r: campo vazio;
			  $buff = substr($buff,1);
		   }else if ($i > 0) {
			  $s = trim(substr($buff,0,$i));
			  $s = str_replace("'","",$s);
			  $a_result[$n] = $s;
			  $buff = substr($buff,$i+1);
		   }
		   $n += 1;
		   $this->fieldCount += 1;
		 } 
		 return $a_result;
	  }

	  function ReadRecord(){
		 if ($this->vOpen === false) {
		    return false;
		 }else{
            $buff = $this->ReadLn();
            if ($this->useFieldNames === true) {
			   return $this->_ConvertToFieldDef($buff);
			}else{
			   return $this->_ConvertToIdxArray($buff);
			}
		 }
	  }


  } //r: Class
?>