<?php 
  /* ---------------------------------------------------------------------------
      uLib Versao 1.0
	  Autor: Alexandre P. Trindade
	  Copyright 2004 - Uniware Acessoria e Consultoria de Sistemas LTDA.
      Inicio: 15/09/2004 
	 ---------------------------------------------------------------------------
  */

  /*{$NC+}*/
  require_once($lib_path."/objects.php"); 
  require_once($lib_path."/lib_misc.php");
  /*{$NC-}*/
  /*{$CB+}
  uses("objects","lib_misc");
  {$CB-}*/

  class uDelphiCon extends uObject {
	  var $lstVars;
	  var $delta;
	  var $fldnames;
	  var $delta_field_sep;
	  var $delta_record_sep;
	  var $hexConv;
	  var $softEncode;
      var $empyValue;
      var $onSend;

	  function uDelphiCon(){
		  $clna = "uDelphiCon";
	      $name      = (func_num_args() > 0)?  func_get_arg(0):"nonamed-$clna";
	      $classPath = (func_num_args() > 1)?  "$clna.".func_get_arg(1):$clna;

		  $this->uObject($name,$classPath); //r: inherited

          $this->lstVars    = array();
		  $this->delta      = array();
		  $this->fldnames   = array();
		  $this->hexConv    = true;
		  $this->softEncode = true;
		  $this->delta_record_sep = chr(13);   //r: Return
		  $this->delta_field_sep  = chr(9);    //r: Tab
		  $this->empyValue = "";               //r: Opcional valor para campo vazio
		  $this->onSend    = "";
	  }

      function Clear(){
          $this->lstVars    = array();
		  $this->delta      = array();
		  $this->fldnames   = array();
	  }

	  function Response($varName,$value){
	     $this->lstVars[$varName] = $value;
	  }
     
	  function ResponseDelta($idx_r,$idx_f,$value){
         //r: verifica se e um campo novo
		 if (!array_key_exists($idx_f,$this->fldnames)){
			 $this->fldnames[$idx_f] = "";
		 }

		 $buf   = ($idx_r >= 0)? $this->delta[$idx_r]:$this->fldnames; //r:Buffer
         $idx_r = ($idx_r >= 0)? $idx_r:count($this->delta);   //r: indice do registro
		 $buf[$idx_f] = $value;
		 $this->delta[$idx_r] = $buf;
		 return $idx_r;
	  }

      function Send($direct){
          if (!empty($this->onSend)){
		     $cmd = $this->onSend . '($this);';
		     eval($cmd);
          }
		  $buff = "<!--\r\n";
		  foreach($this->lstVars as $vn => $vl){
            if (!empty($this->empyValue)){
               $vl = !empty($vl) ? $vl:$this->empyValue;
            }
			$aux = "$vn=$vl";
			if ($this->softEncode){ $aux = SoftEncode($aux,false); }
			if ($this->hexConv) { $aux = str_to_hex($aux); }
			$aux  .= "\r\n";
		    $buff .= $aux;
		  }
          $buff .= "-->";
		  if ($direct){
		     echo $buff;
		  }else{
		    return $buff;
		  }
	  }

      //r: Sincroniza registros. garante que todos os registros no delta possuam
	  //r: os mesmos campos na mesma sequencia
      function _sinc_rec($arec){
	      $result = array();
		  reset($this->fldnames);
		  foreach($this->fldnames as $k => $v){
		      $result[$k] = array_key_exists($k,$arec)? $arec[$k]:"";
		  }
		  return $result;
	  }

	  function SendDelta($direct){
          if (!empty($this->onSend)){
		     $cmd = $this->onSend . '($this);';
		     eval($cmd);
          }
		  $buff = "";
		  foreach($this->delta as $arec){
			$aux = "";
			$arec = $this->_sinc_rec($arec);
			foreach($arec as $k => $v){
               $add = $this->delta_field_sep . $v;
			   $aux .= empty($aux)? $v:$add;
			}
			$add = $this->delta_record_sep.$aux;
			$aux = empty($buff)? $aux:$add;
			if ($this->softEncode){ $aux = SoftEncode($aux,false); }
			if ($this->hexConv) { $aux = str_to_hex($aux); }
		    $buff .= $aux;
		  }
          $buff = "<!--\r\n" . $buff . "\r\n-->";
		  if ($direct){
		     echo $buff;
		  }else{
		    return $buff;
		  }
	  }

	  function SendSQLDelta($direct,$sqlDelta){
          if (!empty($this->onSend)){
		     $cmd = $this->onSend . '($this);';
		     eval($cmd);
          }
		  $buff = "";
		  $first = true;
		  foreach($sqlDelta as $reg){
		    if ($first){
                //r: Lista de campos (1a linha)
                $aux = "";
                foreach($reg as $k => $v){
                   $add = $this->delta_field_sep . $k;
                   $aux .= empty($aux)? $k:$add;
                }
                $first = false;
                reset($reg);
            }
            //r: Dados
			$aux = "";
			foreach($reg as $k => $v){
               $add = $this->delta_field_sep . $v;
			   $aux .= empty($aux)? $v:$add;
			}
			$add = $this->delta_record_sep.$aux;
			$aux = empty($buff)? $aux:$add;
			if ($this->softEncode){ $aux = SoftEncode($aux,false); }
			if ($this->hexConv) { $aux = str_to_hex($aux); }
		    $buff .= $aux;
		  }
          $buff = "<!--\r\n" . $buff . "\r\n-->";
		  if ($direct){
		     echo $buff;
		  }else{
		    return $buff;
		  }
	  }

  }

?>
