<?php
/*
 * Programa    : o_postgre
 * Objetivo    : Conexo com o PostgreSQL
 * Programador : Alexandre P. Trindade
 * Data Incio : 27 de novembro de 2009 - Sexta Feira
 * Data Trmino: 27 de novembro de 2009 - Sexta Feira
 */
 
class  PostgreSQLConnection {
	var $conn       = null;
	var $msg	    = "";
	var $db         = "";
	
	function PostgreSQLConnection($host, $user, $pass, $db,$port = "5432") {
            $con_string = "host=$host port=$port dbname=$db user=$user password=$pass";
		    $this->conn = @pg_connect($con_string) or die("PostgreSQL-Erro na conexo com o banco: " . pg_last_error());
        	$this->db   = $db;
        	$this->executeUpdate("BEGIN");
	}

	function executeUpdate($sql) {
		$nr = pg_query($sql, $this->conn) or die("PostgreSQL-Erro no Update [$sql]".pg_last_error());
		return pg_affected_rows();
	}
   
    function close(){
	   pg_close($this->conn);
	}
}

?>
